extends layout

block content
  .col-md-8.col-md-offset-2
    h1= title

    .panel.panel-primary
      .panel-heading
        span.glyphicon.glyphicon-file.pull-right
        h3.panel-title Enter formatted text

      .panel-body
        #formTemplate.hidden
          .item.clearfix
            textarea(name='text[]' rows=4 required=1).col-xs-11
            .btn-group-vertical.pull-right
              a.pin(href='#' title='Pin and do not permutate this paragraph').btn.btn-info.col-xs-1
                span.glyphicon.glyphicon-pushpin
                input(name='pin[]' value='0').hidden
              a.remove(href='#').btn.btn-danger.col-xs-1.disabled
                span.glyphicon.glyphicon-trash

        form#uploadForm(action='/analyze' method='post' enctype='application/json')
          .option

          a.add(href='#').btn.btn-success
            span.glyphicon.glyphicon-plus

          button.btn.btn-primary.btn-lg.btn-block(type='submit')
            | Analyze 
            span#variants.badge ###
            |  variants

    #results.panel.panel-default
      .panel-heading
        h3.panel-title
          | Results
      .panel-body
        span.cat.label.label-success
        h1.conf
        p.text

    style.
      #uploadForm textarea {
         resize: vertical;
         margin-bottom: 20px;
      }
      #uploadForm .add {
         margin-bottom: 20px;
      }
      #results .panel-body p {
        white-space: pre-wrap;
      }

    script.
      $(document).on("click", ".pin", function (e) {
        var target = $(e.target).closest(".btn");
        let a = 'glyphicon-screenshot';
        let b = 'glyphicon-pushpin';
        let val = (target.find('input').val() == 0);
        if (val) {
          b = [a, a = b][0];
        }
        target.find('input').val(val ? '1' : '0');
        target.find('span').removeClass(a).addClass(b);
        UpdateVariantsCounter();
        e.preventDefault();
      });

      $(document).on("click", ".add", function (e) {
        var target = $(e.target).closest(".btn");
        var option = target.parent().find('.option');

        let cnt = option.find('.item').length;
        if (cnt < 7) {
          var clone = $('#formTemplate').find(".item").first().clone();
          clone.hide().fadeIn();
          option.append(clone);
          UpdateVariantsCounter();

          option.find(".remove").removeClass('disabled');
          if (cnt == 6) {
            option.next(".add").fadeOut();
          }
        }
        e.preventDefault();
      });

      $(document).on("click", ".remove", function (e) {
        var target = $(e.target).closest(".btn");
        var option = target.parents('.option');

        let cnt = option.find(".item:not(:animated)").length;
        if (1 < cnt) {
          let parent = target.parents('.item');
          option.find(".add").fadeIn();
          if (cnt == 2) {
            option.find(".item").not(parent).find(".remove").addClass('disabled');
          }

          parent.hide(function () {
            $(this).remove();
            UpdateVariantsCounter();
          });
        }
        e.preventDefault();
      });

      $('#uploadForm').submit(function (e) {
        Analyze('#uploadForm');
        pb.insertAfter($(this)).hide()
          .width($(this).outerWidth())
          .height($(this).outerHeight());
        //$(this).fadeOut(function() {
        //  $(this).remove();
        //  pb.fadeIn();
        //});
        //$('#uploadForm *').addClass('disabled').find(':input').attr('disabled', true).css('resize', 'none');
        e.preventDefault();
      });

      function UpdateVariantsCounter() {
        let c = $('#uploadForm .option').find('.item .glyphicon-pushpin').length;
        $('#variants').text(factorial(c));
      }
      var pb = $('<div class="progress" style="margin-bottom: 0"><div class="progress-bar progress-bar-striped active" role="progressbar" style="width: 0%"><span class="sr-only">##%</span></div></div>');
      function setProgress(w) {
        pb.find('.progress-bar').width(w);
        pb.find('.sr-only').text(w + ' completed');
      }

      $('#uploadForm .add').click();
      $('#uploadForm .remove').addClass('disabled');

      function Analyze(formId) {
        $(formId).ajaxSubmit({
          success: function(data) {
            console.log(data);
            AnalyzePoll(data.url);
          },
          error: function(e) {
            console.log(e);
            showAlertBox(e.status + ': ' + e.statusText);
          },
          timeout: 30000
        });
      }

      function AnalyzePoll(url) {
        function Repeat() {
          setTimeout(() => {
              AnalyzePoll(url);
          }, 1000);
        }
        $.ajax({
          url: url,
          method: 'GET',
          success: function(data) {
            if (data.error !== undefined) {
              console.error(data.error);
              showAlertBox(data.error.message);
            } else {
              console.log(data);
              setProgress(data.info.progress);
              if (!data.info.done) {
                Repeat();
              }
              $('#results .cat').text(data.conf.name);
              $('#results .conf').text(Math.round(data.conf.confidence * 1000) * 0.1 + '%');
              $('#results .text').text(data.text);
            }
          },
          error: function(e) {
            console.error(e);
            showAlertBox(e.status + ': ' + e.statusText);
            if (e.statusText != 'timeout') {
              Repeat();
            }
          },
          timeout: 30000
        });
      }
